function [A1r,A2r,A3r,A4r,IN,HITS]=GetA_From_GUI_Time_Vary
global N N_constr N_max
handles = guidata(1);
N = [N_max(3),N_max(4)];

[J,I] = find(ones(N(2)+1,N(1)+1));
I=I-1;     J=J-1;
lenA = length(I);
IX = [1:lenA]';   % the enumeration is given in this case by: IX=(J*(N(1)+1)+I+1))
[IN,IN_1p,IN_1m,IN_2p,IN_2m] =IN_and_OUT_of_Projection(I,J,IX);
if handles.File==0
    Prop = [handles.Prop1(I(IN),J(IN)),...
                handles.Prop2(I(IN),J(IN)),...
                handles.Prop3(I(IN),J(IN)),...
                handles.Prop4(I(IN),J(IN))];
else
    [S,Prop] = handles.PropFunct(I(IN),J(IN),t);
end
  
N_glob_total = length(I)+N_constr;

A1 = sparse(IN,IN,-Prop(:,1),N_glob_total,N_glob_total)+...
    sparse(IN_1p,IN,Prop(:,1),N_glob_total,N_glob_total);
A2 = sparse(IN,IN,-Prop(:,2),N_glob_total,N_glob_total)+...
    sparse(IN_1m,IN,Prop(:,2),N_glob_total,N_glob_total);
A3 = sparse(IN,IN,-Prop(:,3),N_glob_total,N_glob_total)+...
    sparse(IN_2p,IN,Prop(:,3),N_glob_total,N_glob_total);
A4 = sparse(IN,IN,-Prop(:,4),N_glob_total,N_glob_total)+...
    sparse(IN_2m,IN,Prop(:,4),N_glob_total,N_glob_total);


IN_and_Sinks = [IN;[length(I)+1:length(I)+N_constr]'];
A1r = A1(IN_and_Sinks,IN_and_Sinks);
A2r = A2(IN_and_Sinks,IN_and_Sinks);
A3r = A3(IN_and_Sinks,IN_and_Sinks);
A4r = A4(IN_and_Sinks,IN_and_Sinks);

HITS = sparse(I(IN)+1,J(IN)+1,ones(size(I(IN))));

end

function [IN,IN_1p,IN_1m,IN_2p,IN_2m] = IN_and_OUT_of_Projection(I,J,IX)
global N_max N
N_constr = length(N_max);
N_max_ar = repmat(N_max,length(I),1);    % Form a tiled matrix of [N_max;N_max;...] of the same length as I and J.

TMP_0 =sparse((Projection_Shape_Functions(I,J)>N_max_ar));   % Form a matrix of zeros for states that satisfy constraints and 1's for states that don't.
IN = IX(max(TMP_0,[],2)==0);  % Output the indecies of all states in the Projections space.

IN_2 = (Projection_Shape_Functions(I(IN)+1,J(IN))<=N_max_ar(IN,:));
IN_1p = ((I(IN)+1)*(N(2)+1)+(J(IN))+1).*(min(IN_2,[],2)==1)+(length(I)+1)*(IN_2(:,1)==0);
for i=2:N_constr
    IN_1p=IN_1p+(length(I)+i)*(IN_2(:,1)==1).*min(IN_2(:,1:i-1),[],2).*(IN_2(:,i)==0);
end

IN_2 = (Projection_Shape_Functions(I(IN)-1,J(IN))<=N_max_ar(IN,:));
IN_1m = ((I(IN)-1)*(N(2)+1)+(J(IN))+1).*(min(IN_2,[],2)==1)+(length(I)+1)*(IN_2(:,1)==0);
for i=2:N_constr
    IN_1m=IN_1m+(length(I)+i)*(IN_2(:,1)==1).*min(IN_2(:,1:i-1),[],2).*(IN_2(:,i)==0);
end

IN_2 = (Projection_Shape_Functions(I(IN),J(IN)+1)<=N_max_ar(IN,:));
IN_2p = ((I(IN))*(N(2)+1)+(J(IN)+1)+1).*(min(IN_2,[],2)==1)+(length(I)+1)*(IN_2(:,1)==0);
for i=2:N_constr
    IN_2p=IN_2p+(length(I)+i)*(IN_2(:,1)==1).*min(IN_2(:,1:i-1),[],2).*(IN_2(:,i)==0);
end

IN_2 = (Projection_Shape_Functions(I(IN),J(IN)-1)<=N_max_ar(IN,:));
IN_2m = ((I(IN))*(N(2)+1)+(J(IN)-1)+1).*(min(IN_2,[],2)==1)+(length(I)+1)*(IN_2(:,1)==0);
for i=2:N_constr
    IN_2m=IN_2m+(length(I)+i)*(IN_2(:,1)==1).*min(IN_2(:,1:i-1),[],2).*(IN_2(:,i)==0);
end

end